
#include "photonmap.h"
#include "world.h"

Photon::Photon() { }

Photon::~Photon() { }

void Photon::getPosition(const Photon &photon, Vector3 &outPosition)
{
    outPosition = photon.position;
}

bool Photon::equals(const Photon &p, const Photon &q)
{
    return p == q;
}

bool Photon::operator==(const Photon &other) const
{
    return position == other.position &&
           wi == other.wi &&
           power == other.power;
}

void PhotonMap::render(RenderDevice *dev, World *world)
{
    dev->pushState();
    dev->setProjectionAndCameraMatrix(world->camera()->projection(),
                                      world->camera()->frame());

    // TODO draw world in wireframe

    dev->beginPrimitive(PrimitiveType::POINTS);

    for (PhotonMap::Iterator photon = begin(); photon.isValid(); ++photon) {
        dev->setColor(photon->power / photon->power.max());
        dev->sendVertex(photon->position);
    }

    dev->endPrimitive();
    dev->popState();
}

